
MapNode = {}
MapNode.__index = MapNode

mapList = {}

wayPointMap = nil;
wayPointX = 0
wayPointY = 0

function MapNode.create(map_name)
   local node = {}
   setmetatable(node,MapNode)
   node.mapName = map_name
   node.connections = {}
   node.searched = false;
   mapList[map_name] = node;
   return node
end

function MapNode:connect(other_node)
	table.insert(self.connections, other_node);
	table.insert(other_node.connections, self);
end

function MapNode:connect_one_way(other_node)
	table.insert(self.connections, other_node);
end

function getMap(name)
	return mapList[name];
end

function find_node(start_name, end_name)
	resetSearchedFlag()
	if (mapList[start_name] == nil or mapList[end_name] == nil) then
		return
	end

	if (start_name == end_name) then
		--DoCall("MBox", "Mark location")
		DoCall("MarkLocation", wayPointX, wayPointY)
		return;
	end
	
	local start_node = mapList[start_name]
	local end_node = mapList[end_name]
	local numConnections = table.getn(start_node.connections);
	
	start_node.searched = true;
	
	for i=1, numConnections do
		if (traverse_node(start_node.connections[i], start_node, end_node) ~= nil) then
			--DoCall("MBox", start_node.connections[i].mapName)
			DoCall("MarkExit", start_node.connections[i].mapName)
			return;
		end
	end
end

function traverse_node(curr_node, parent_node, end_node)
	
	if (curr_node.mapName == end_node.mapName) then
		return 10;
	end
	
	local numConnections = table.getn(curr_node.connections);
	if (curr_node.searched == false) then
		curr_node.searched = true;
		for i=1, numConnections do
			if (parent_node == nil or curr_node.connections[i].mapName ~= parent_node.mapName) then
				local returnVal = traverse_node(curr_node.connections[i], curr_node, end_node)
				if (returnVal ~= nil) then
					return returnVal;
				end
			end
		end
	end
	return nil;
end

function resetSearchedFlag()
	for i=1, table.getn(mapList) do
		mapList[i].searched = false;
	end
end

function connect(map_a, map_b)
	if (mapList[map_a] == nil) then
		MapNode.create(map_a)
	end
	if (mapList[map_b] == nil) then
		MapNode.create(map_b)
	end
	if (mapList[map_a] == nil or mapList[map_b] == nil) then
		return
	end
	
	mapList[map_a]:connect(mapList[map_b])
end

function connect_one_way(map_a, map_b)
	if (mapList[map_a] == nil) then
		MapNode.create(map_a)
	end
	if (mapList[map_b] == nil) then
		MapNode.create(map_b)
	end
	if (mapList[map_a] == nil or mapList[map_b] == nil) then
		return
	end
	
	mapList[map_a]:connect_one_way(mapList[map_b])
end

-- outer savin

connect_one_way("start",	 	"elevator_0a")
connect_one_way("mall_roof",	"elevator_0a")
connect_one_way("elevator_0a",	"mall_01_alert")
connect_one_way("mall_01_alert","elevator_0b")
connect_one_way("mall_01",		"elevator_0b")
connect_one_way("elevator_0b",	"mall_roof")
connect_one_way("mall_01_alert", "stairwell_01")
connect("stairwell_01", "mall_01")
connect("stairwell_01", "mall_02")
connect("mall_02", "mall_03_storage")
connect("mall_02", "mall_bathroom")
connect("mall_02", "mall_03")
--connect_one_way("mall_04_02", "mall_03")
--connect_one_way("mall_04_02", "mall_03_gas")
connect("mall_04", "mall_03")
connect("mall_04", "mall_03_gas")
connect("mall_05", "mall_04")
connect("mall_05", "mall_ladies")
connect("mall_05", "mall_hallway_01")
connect("mall_milkman", "mall_hallway_01")
connect("mall_milkman", "mall_stairway_01")
connect_one_way("mall_milkman_2", "mall_hallway_01")
connect_one_way("mall_milkman_2", "mall_stairway_01")
connect("mall_stairway_01", "mall_06")
connect("mall_06", "gardens_01")
connect("mall_06", "mall_buffet")
connect("gardens_01", "gardens_02")
connect("gardens_02", "gardens_03")
connect("gardens_03", "mall_07")
connect("mall_07", "mall_mannequin")
connect("mall_mannequin", "mall_02_storage")
connect_one_way("mall_02_storage_2", "mall_mannequin")
connect("mall_07", "mall_08")
connect("mall_08", "elevator_pgun")
connect("mall_08", "mall_09")
connect("mall_10", "mall_09")
connect("mall_10", "mall_11")
connect("mall_11", "mall_12")
connect("mall_12", "mall_14")
connect("mall_15", "mall_14")
connect("mall_15", "mall_16")
connect("mall_17", "mall_16")
connect("mall_03_gas", "mall_end_01")
connect("mall_end_01", "mall_end_02")
connect_one_way("mall_end_02", "elevator_song")
connect_one_way("elevator_song", "mall_13")
connect("elevator_10th", "mall_13")
connect_one_way("mall_13","elevator_fin")

function getWaypoint()

	if (getCurrMapName() == "mall_13" or getCurrMapName() == "elevator_10th") then
		setWaypoint("elevator_fin", 16, 4, "Head to the elevator to the 1st floor");
		return;	
	end

	if (getflag(ACT_2_REACHED) == 1) then
		setWaypoint("null", 0, 0, "");
		return;
	end
	if (getCurrMapName() == "milkman_2") then
		setWaypoint("null", 0, 0, "Defeat the Ghost of Christmas Present");
		return;
	end
	
	if (getitem(2) == 0 and getitem(9) == 1 and getCurrMapName() == "mall_12" ) then
		setWaypoint("mall_12", 34, 10, "Search for Who's little gift");
		return
	end
	
	if (getflag(STOCKING_EN_FLAG) == 1 and getitem(9) == 0) then
		setWaypoint("mall_roof", 11, 4, "Find a helpful item on the roof of outer savin'");
		return;
	end
	
	if (getCurrMapName() == "mall_02_storage_2") then
		setWaypoint("mall_17", 12, 11, "Escape from the TADPOLES");
		return;
	end

	if (getCurrMapName() == "mall_08" and getflag(DIEHARD) == 0) then
		setWaypoint("elevator_pgun", 20, 13, "Check the elevator")
		return;
	end
	
	if (getCurrMapName() == "elevator_pgun" and getflag(DIEHARD) == 0) then
		setWaypoint("elevator_pgun", 20, 13, "Investigate the elevator")
		return;
	end
	
	if (getCurrMapName() == "mall_02_storage" and getitem(6) == 0) then
		setWaypoint("mall_02_storage", 25, 9, "Search for any useful items");
		return;
	end
	
	if (getitem(10) == 1 and getitem(6) == 0) then
		setWaypoint("mall_02_storage", 25, 9, "Use the Toast to get to the storage room");
		return
	end
	
	if (getflag(STORAGE_01) == 1 and getflag(MANNEQUIN_FLAG) == 1 and getflag(REVOLTING_OPEN_FLAG) == 1 and getitem(10) == 0 and getitem(6) == 0) then
		setWaypoint("mall_buffet", 8, 7, "Investigate The Revolting Omelet");
		return
	end
	
	if (getflag(STORAGE_01) == 1 and getflag(MANNEQUIN_FLAG) == 0) then
		setWaypoint("mall_02_storage", 25, 9, "Check the storage room");
		return
	end
	if (getCurrMapName() == "mall_ladies" and getitem(3) == 0) then
		setWaypoint("mall_ladies", 15, 20, "Search for any useful items");
		return;
	end
	if (getCurrMapName() == "mall_hallway_01" and getflag(WHITE_BLOOD) == 0) then
		setWaypoint("mall_ladies", 15, 20, "Investigate the blood trail");
		return;
	end
	if (getCurrMapName() == "mall_05" and getitem(3) == 0) then
		setWaypoint("mall_ladies", 15, 20, "Investigate the ladies' room");
		return;
	end
	if (getCurrMapName() == "mall_03_storage_2") then
		setWaypoint("mall_17", 12, 11, "Escape the storage room");
		return;
	end

	if (getflag(WHITE_BLOOD) ~= 0 and getflag(MILKMAN_MEET) == 0) then
		setWaypoint("mall_milkman", 31, 20, "Investigate the source of the blood");
		return;
	end

	if (getCurrMapName() == "start") then
		setWaypoint("mall_17", 12, 11, "Head inside Outer Savin' mall");
		return;
	end
	if (getflag(STAIRWELL_FLAG) == 0) then
		setWaypoint("stairwell_01", 22, 10, "Learn the Ghosts' plan");
		return;
	end
	if (getflag(COSTUME_STORE_FLAG) == 1 and getitem(7) == 0) then
		setWaypoint("mall_03_storage", 25, 9, "Check the storage room");
		return;
	end
	if (getflag(ELEVATOR_01_FLAG) == 0) then
		setWaypoint("mall_02", 28, 15, "Take the elevator to the first floor");
		return;
	end
	
	if (getflag(WONT_BUDGE_FLAG) == 1 and getflag(MEET_WHO) == 0) then
		setWaypoint("mall_03_gas", 10, 26, "Find an alternate route");
		return
	end
	
	if (getflag(ELEVATOR_BUSTED) == 1 and getitem(4) == 0) then
		setWaypoint("mall_17", 13, 24, "Investigate the Elevator Room further");
		return;
	end
	
	if (getflag(ELEVATOR_BUSTED) == 1 and getitem(4) == 1 and getflag(SHUT_OFF_FLOOR) == 0) then
		setWaypoint("mall_03_gas", 16, 4, "Deactivate the electrical switchboard with the Missiletoe Launcher");
		return;	
	end

	if (getflag(ELEVATOR_BUSTED) == 1 and getitem(4) == 1 and getflag(SHUT_OFF_FLOOR) == 1) then
		setWaypoint("mall_13", 16, 4, "Head to the elevator to the 10th floor");
		return;	
	end

	
	setWaypoint("mall_17", 12, 11, "Find an elevator to the 1st floor");
	
end

function setWaypoint(mapname, posx, posy, str)
	wayPointMap = mapname;
	wayPointX = tonumber(posx)
	wayPointY = tonumber(posy)
	--DoCall("MBox", mapname .. " " .. getCurrMapName())
	updateWayPoint()
	DoCall("SetWaypointText", str)
end

function getCurrMapName()
	return DoCall("GetCurrMap")
end

function updateWayPoint()
	find_node(getCurrMapName(),wayPointMap)
end